/*
 * matriu.c
 *      Matriu de reals.
 */

#include <assert.h>
#include <stdlib.h>

#include "matriu.h"

/* Implementacio de les operacions */

Matriu
CrearMatriu(int nf, int nc)
{
    Matriu m;

    assert(nf > 0 && nc > 0);
    m.nf = nf;
    m.nc = nc;
    m.telem = (float *)malloc(nf * nc * sizeof (float));

    assert(m.telem != NULL);
    return m;
}

int
FilesMatriu(Matriu m)
{
    return m.nf;
}

int
ColsMatriu(Matriu m)
{
    return m.nc;
}

void
AssigMatriu(Matriu * const m, int i, int j, float f)
{
    assert(0 <= i && i < (*m).nf && 0 <= j && j < (*m).nc);
    (*m).telem[i * (*m).nc + j] = f;
}

float
ConsMatriu(Matriu m, int i, int j)
{
    assert(0 <= i && i < m.nf && 0 <= j && j < m.nc);
    return m.telem[i * m.nc + j];
}

void
DestruirMatriu(Matriu * const m)
{
    free((*m).telem);
}
