
/*
 * mdaccall.c
 *      Accedeix a memoria previament alliberada
 */

/*
 * Inclusions estandard
 */
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/*
 * Prototipus
 */
int *CrearEnter(void);
void DestruirEnter(int *i);

float *CrearReal(void);
void DestruirReal(float *f);

void EscriureReal(float f);

/*
 * Programa principal
 */
int
main(void)
{
    int *e;
    float *r;

    r = CrearReal();
    *r = 3.78;
    EscriureReal(*r);
    DestruirReal(r);
    e = CrearEnter();
    *e = 8999;
    EscriureReal(*r);
    DestruirEnter(e);

    return EXIT_SUCCESS;
}

/*
 * Implementacio dels subprogrames
 */
int *
CrearEnter(void)
{
    int *i;

    i = malloc(sizeof (int));

    assert(i != NULL);
    return i;
}

void
DestruirEnter(int *i)
{
    free(i);
}

float *
CrearReal(void)
{
    float *f;

    f = malloc(sizeof (float));

    assert(f != NULL);
    return f;
}

void
DestruirReal(float *f)
{
    free(f);
}

void
EscriureReal(float f)
{
    int ret;

    ret = printf("%g\n", f);
    assert(ret > 0);
}
