
/*
 * mdallnr.c
 *      Allibera memoria no reservada previament.
 */

/*
 * Inclusions estandard
 */
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

/*
 * Prototipus
 */
void EscriureEnter(int i);

char *CrearCaracter(void);
void DestruirCaracter(char *c);

/*
 * Programa principal
 */
int
main(void)
{
    int i, *ip;
    char *c;

    i = 3;
    ip = &i;
    EscriureEnter(i);
    free(ip);
    c = CrearCaracter();
    *c = 'a';
    DestruirCaracter(c);
    EscriureEnter(i);

    return EXIT_SUCCESS;
}

/*
 * Implementacio dels subprogrames
 */
void
EscriureEnter(int i)
{
    int ret;

    ret = printf("%d\n", i);
    assert(ret > 0);
}

char *
CrearCaracter(void)
{
    char *c;

    c = malloc(sizeof (char));

    assert(c != NULL);
    return c;
}

void
DestruirCaracter(char *c)
{
    free(c);
}
