
/*
 * mdelem.c
 *      Reserva i alliberament de memoria per tipus elementals.
 */

/*
 * Inclusions estandard
 */
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

/*
 * Inclusions
 */

/*
 * Prototipus
 */
char *CrearCaracter(void);
void DestruirCaracter(char *c);

int *CrearEnter(void);
void DestruirEnter(int *i);

float *CrearReal(void);
void DestruirReal(float *f);

bool *CrearBoolea(void);
void DestruirBoolea(bool * b);

void EscriureCaracter(char c);
void EscriureEnter(int i);
void EscriureReal(float f);

/*
 * Programa principal
 */
int
main(void)
{
    char *a;
    int *b;
    float *c;
    bool *d;

    /*
     * caracter
     */
    a = CrearCaracter();
    *a = 'x';
    EscriureCaracter(*a);
    EscriureCaracter('\n');
    DestruirCaracter(a);
    /*
     * enter
     */
    b = CrearEnter();
    *b = 123;
    EscriureEnter(*b + 3);
    EscriureCaracter('\n');
    DestruirEnter(b);
    /*
     * real
     */
    c = CrearReal();
    *c = 12.3;
    EscriureReal(*c - 0.3);
    EscriureCaracter('\n');
    DestruirReal(c);
    /*
     * boolea
     */
    d = CrearBoolea();
    *d = true;
    if (!*d && true) {
	EscriureCaracter('F');
    } else if (*d || false) {
	EscriureCaracter('C');
    } else
	assert(0);
    EscriureCaracter('\n');
    DestruirBoolea(d);

    return EXIT_SUCCESS;
}

/*
 * Implementacio dels subprogrames
 */
char *
CrearCaracter(void)
{
    char *c;

    c = malloc(sizeof (char));

    assert(c != NULL);
    return c;
}

void
DestruirCaracter(char *c)
{
    free(c);
}

int *
CrearEnter(void)
{
    int *i;

    i = malloc(sizeof (int));

    assert(i != NULL);
    return i;
}

void
DestruirEnter(int *i)
{
    free(i);
}

float *
CrearReal(void)
{
    float *f;

    f = malloc(sizeof (float));

    assert(f != NULL);
    return f;
}

void
DestruirReal(float *f)
{
    free(f);
}

bool *
CrearBoolea(void)
{
    bool *b;

    b = malloc(sizeof (bool));
    assert(b != NULL);
    return b;
}

void
DestruirBoolea(bool * b)
{
    free(b);
}

void
EscriureCaracter(char c)
{
    putchar(c);
}

void
EscriureEnter(int i)
{
    int ret;

    ret = printf("%d", i);
    assert(ret > 0);
}

void
EscriureReal(float f)
{
    int ret;

    ret = printf("%g", f);
    assert(ret > 0);
}
