/*
 * mdsino.c
 *      Sinonims
 */

/*
 * Inclusions estandard
 */
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/*
 * Definicions de tipus
 */
typedef int TauEnter[10];

/*
 * Prototipus
 */
int *CrearEnter(void);
void DestruirEnter(int *i);

/*
 * Programa principal
 */
int
main(void)
{
    int i, *ip;
    TauEnter t;
    int *t3;
    int *p1, *p2;

    /*
     * i i *ip son sinonims
     */
    ip = &i;
    i = 3;
    printf("i = %d, *ip = %d\n", i, *ip);
    *ip = 2;
    printf("i = %d, *ip = %d\n", i, *ip);
    /*
     * t[3] i *t3 son sinonims
     */
    t[0] = 5;
    t[3] = 10;
    t3 = &t[3];
    printf("t[0] = %d, t[3] = %d, *t3 = %d\n", t[0], t[3], *t3);
    *t3 = 7;
    printf("t[0] = %d, t[3] = %d, *t3 = %d\n", t[0], t[3], *t3);
    /*
     * p1 i p2 apunten dos objectes diferents
     */
    p1 = CrearEnter();
    *p1 = 2;
    p2 = CrearEnter();
    *p2 = 3;
    printf("*p1(%p) = %d, *p2(%p) = %d\n", p1, *p1, p2, *p2);
    /*
     * p1 i p2 continuen apuntant dos objectes diferents pero amb
     * el mateix valor
     */
    *p1 = *p2;
    printf("*p1(%p) = %d, *p2(%p) = %d\n", p1, *p1, p2, *p2);
    /*
     * p1 i p2 son sinonims: apunten el mateix objecte.
     * L'objecte apuntat per p1 abans de l'assignacio
     * es una referencia penjada.
     */
    p1 = p2;
    printf("*p1(%p) = %d, *p2(%p) = %d\n", p1, *p1, p2, *p2);
    DestruirEnter(p1);
    /*
     * Error: alliberem 2 cops el mateix espai
     */
    DestruirEnter(p2);

    return EXIT_SUCCESS;
}

/*
 * Implementacio dels subprogrames
 */
int *
CrearEnter(void)
{
    int *i;

    i = malloc(sizeof (int));

    assert(i != NULL);
    return i;
}

void
DestruirEnter(int *i)
{
    free(i);
}
