
/*
 * mdtaula.c
 *      Reserva i alliberament de memoria per tipus taula
 */

/*
 * Inclusions estandard
 */
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/*
 * Definicions de constants
 */
#define N 10
#define M (N + 10)

/*
 * Definicions de tipus
 */
typedef char TauCar[N];

typedef struct
{
    int nelem;
    TauCar telem;
}
Cadena;

typedef Cadena TauCadena[M];

/*
 * Prototipus
 */
TauCar *CrearTauCar(void);
void DestruirTauCar(TauCar * t);

TauCadena *CrearTauCadena(void);
void DestruirTauCadena(TauCadena * t);

void EscriureCaracter(char c);
void EscriureCadena(Cadena c);

/*
 * Programa principal
 */
int
main(void)
{
    TauCar *tc;
    TauCadena *tcad;

    /*
     * TauCar
     */
    tc = CrearTauCar();
    (*tc)[0] = 'a';
    (*tc)[5] = 'b';
    EscriureCaracter((*tc)[0]);
    EscriureCaracter((*tc)[5]);
    EscriureCaracter('\n');
    DestruirTauCar(tc);
    /*
     * TauCadena
     */
    tcad = CrearTauCadena();
    (*tcad)[0].nelem = 3;
    (*tcad)[0].telem[0] = 'x';
    (*tcad)[0].telem[1] = 'y';
    (*tcad)[0].telem[2] = 'z';
    (*tcad)[2].nelem = 4;
    (*tcad)[2].telem[0] = 'a';
    (*tcad)[2].telem[1] = 'b';
    (*tcad)[2].telem[2] = 'c';
    (*tcad)[2].telem[3] = 'd';
    EscriureCadena((*tcad)[0]);
    EscriureCadena((*tcad)[2]);
    DestruirTauCadena(tcad);

    return EXIT_SUCCESS;
}

/*
 * Implementacio dels subprogrames
 */
TauCar *
CrearTauCar(void)
{
    TauCar *t;

    t = malloc(sizeof (TauCar));
    assert(t != NULL);
    return t;
}

void
DestruirTauCar(TauCar * t)
{
    free(t);
}

TauCadena *
CrearTauCadena(void)
{
    TauCadena *t;

    t = malloc(sizeof (TauCadena));
    assert(t != NULL);
    return t;
}

void
DestruirTauCadena(TauCadena * t)
{
    free(t);
}

void
EscriureCaracter(char c)
{
    putchar(c);
}

void
EscriureCadena(Cadena c)
{
    int i;

    i = 0;
    while (i < c.nelem) {
	EscriureCaracter(c.telem[i]);
	i = i + 1;
    }
    EscriureCaracter('\n');
}
